//--OpenObject for SuperCollider by Julian Rohrhuber
//--this demo was made at subnet/salzburg 2009


//--boot the server
s.boot


//--create some synth definitions...
(
SynthDef(\subnetKick, {|freq= 180, amp= 0.5, rel= 0.2, t_trig|
	var env= EnvGen.kr(Env.asr(0, 1, rel), t_trig);
	var src= SinOsc.ar(freq*[1, 1.01]*env, 0, amp);
	Out.ar(0, src*env);
}).add;
SynthDef(\subnetHat, {|freq= 8000, amp= 0.5, rel= 0.2, t_trig|
	var env= EnvGen.kr(Env.asr(0.005, 1, rel), t_trig);
	var src= BPF.ar(PinkNoise.ar(env), freq*(env+0.1));
	Out.ar(0, Pan2.ar(src, 0, env*amp));
}).add;
SynthDef(\subnetBass, {|freq= 80, amp= 0.5, atk= 0.01, rel= 0.5, gate, fmod= 3|
	var env= EnvGen.kr(Env.adsr(atk, 0.5, 0.9, rel), gate);
	var src= SinOsc.ar(0, BPF.ar(LFSaw.ar(freq, 0, fmod), freq*(env+0.1), env+0.2), amp);
	Out.ar(0, Pan2.ar(src, 0, env));
}).add;
)

//--create the synth objects...
a= Synth(\subnetKick)
b= Synth(\subnetHat)
c= Synth(\subnetBass)


//--open synths for external control...
OpenObject.start
a.publish(\kick)
b.publish(\hat)
c.publish(\bass)


//now open the file openobject_demo01_max.maxpat in maxmsp


//--stop and clean up...
a.unpublish(\kick)
b.unpublish(\hat)
c.unpublish(\bass)
OpenObject.end
c.free
b.free
a.free
